
//AJAX Global

var isIE = false;
var req;

function loadXMLDoc(url) {
    if (window.XMLHttpRequest) {
        req = new XMLHttpRequest();
        req.onreadystatechange = processReqChange;
        req.open("GET", url, true);
        req.send(null);
    } else if (window.ActiveXObject) {
        isIE = true;
        req = new ActiveXObject("Microsoft.XMLHTTP");
        if (req) {
            req.onreadystatechange = processReqChange;
            req.open("GET", url, true);
            req.send();
        }
    }
}

function getElementTextNS(prefix, local, parentElem, index) {
    var result = "";
    if (prefix && isIE) {
        result = parentElem.getElementsByTagName(prefix + ":" + local)[index];
    } else {
        result = parentElem.getElementsByTagName(local)[index];
    }
    if (result) {
        if (result.childNodes.length > 1) {
            return result.childNodes[1].nodeValue;
        } else {
            if (result.firstChild != null)
            {
                return result.firstChild.nodeValue;    		                
            }
            else
            {
                return "";
            }
        }
    } else {
        return "";
    }
}

//User.js

function processReqChange() {
    if (req != null)
    {
        if (req.readyState == 4) {
            if (req.status == 200) {
                ipxresponse();
                document.getElementById("ajax_loading").style.visibility = "hidden";
            } 
            //else { "processReqChange: There was a problem retrieving the XML data:\n" + req.statusText;        }
        }
        else
        {
            if (document.getElementById("ajax_loading") != null)
                document.getElementById("ajax_loading").style.visibility = "visible";
        }    
    }    
}

function showMakeCall(atelno)
{

    window.scrollTo(0,0);
    document.getElementById("makeCallDiv").height = "100px";
    document.getElementById("makeCallDiv").innerHTML = "<table style='width:100%; border:1px solid black'><tr><td><h1>Calling: " + atelno + " ...</h1></td></tr></table>";
      
}

function hideMakeCall()
{
    document.getElementById("makeCallDiv").innerHTML = "";
    document.getElementById("makeCallDiv").height = "0px";
}

function SetPhoneUpdateTimer(newInterval)
{
    if (PhoneIntervalValue != newInterval)
    {
        PhoneIntervalValue = newInterval;
        window.clearInterval(PhoneIntervalId);
        PhoneIntervalId = window.setInterval("loadXMLDoc(updateurl,phonetype);",newInterval);
    }
}

function isNull(val){return(val==null);}

function ipxresponse(){
    var s;
    
    // SpliceCom
    if (phonetype == 0)
    {
        s = "";
        try
        {        
            var connected = getElementTextNS("", "connected", req.responseXML, 0);
            var error = getElementTextNS("", "error", req.responseXML, 0);
            
            var calls = req.responseXML.getElementsByTagName("call");
            if (error != "")
            {
                s += "<ul><li>Sorry there was an error: " + error + "</li></ul>";
                SetPhoneUpdateTimer(5000);
            }
            else if (connected == 0)
            {
                s += "<ul><li>Unable to contact remote unit at the moment, system will attempt to reconnect in a second.</li></ul>";    
                SetPhoneUpdateTimer(3000);
            }        
            else if (calls.length > 0)
            {   
                hideMakeCall();
                var conferenceInProgress = false;
                var currentcall = getElementTextNS("", "currentcall", req.responseXML, 0);
                var altcall = getElementTextNS("", "altcall", req.responseXML, 0);
                SetPhoneUpdateTimer(5000);
                var gs = "";
                
                s="";
                
                for (var i = 0; i < calls.length; i++) 
                {
                    var cid = getElementTextNS("", "callid", calls[i], 0) ;
                    var cstat = getElementTextNS("", "state", calls[i], 0) ;
                    var conferenced = getElementTextNS("", "conferenced", calls[i], 0);
                    
                    s += "<ul>";
//                    if (cid == currentcall)
//                    {
//                        s += "<ul>";
//                    }
//                    else
//                    {
//                        s += "<ul class=idle>";
//                    }
                    
                    if (cid == currentcall)
                    {
                        s += "\n<li><img src=Images/Splice/idle.png  border=0> ";
                    }
                    else if (conferenced == "1" || conferenceInProgress == true)
                    {
                        s += "\n<li><img src=Images/Splice/ringing.png  border=0> ";
                    }
                    else
                    {
                        s += "\n<li><img src=Images/Splice/busy.png  border=0> ";
                    } 

                    if (cstat == 4)
                        s += "Proceding";
                    else if (cstat == 5)
                        s += "Establishing";
                    else if (cstat == 6)
                        s += "Ringing (OutGoing)";
                    else if (cstat == 9)
                        s += "Ringing (Incoming)";
                    else if (cstat == 7)
                        s += "Connected";
                    else if (cstat == 8)
                        s += "Disconnecting";
                    
                    s+= "</li>";
                                        
                    if (conferenced  == "1")
                    {
                        conferenceInProgress = true;
                    }
                    
                    s += "<li>" + getElementTextNS("", "cn", calls[i], 0) + "<span class=\"secondaryWLink\">" +  getElementTextNS("", "telephone", calls[i], 0) + "</span></li>";
                    s += "<li>" + getElementTextNS("", "local_cn", calls[i], 0) + "<span class=\"secondaryWLink\">" +  getElementTextNS("", "local_telephone", calls[i], 0) + "</span></li>";
                    s+= "</ul>";
                    
                    s+= "<table>";
                    s+= "<tr>";
                    
                    // Hangup
                    s += "<td><a target=resultframe href=" + actionurl + "&callid=" + cid + "&submit=release onclick=DelayPhonePoll()><img src=\"css/images/hangup.png\" border=0 height=75px width=75px alternate=\"Hangup\"></a></td>";
                    
					// Switch Call
					if (cstat == 9)
                    {
                        if( cid!=currentcall)
                        {
                            s += "<td><a target=\"resultframe\" href=\"" + actionurl + "&callid=" + cid + "&submit=SwitchPickup\" onclick=\"DelayPhonePoll()\"><img src=\"css/images/phone.png\" border=0 height=75px width=75px alternate=\"Speak to this call\"></a></td>";
                        }
                        else
                        {
                             s += "<td><a target=\"resultframe\" href=\"" + actionurl + "&callid=" + cid + "&submit=Answer\" onclick=\"DelayPhonePoll()\"><img src=\"css/images/phone.png\" border=0 height=75px width=75px alternate=\"Speak to this call\"></a></td>";
                        }
                    }
                    else if ( cstat==7 )
                    {
                        if( cid==currentcall || conferenceInProgress)
                        {
                            s += "<td><a target=\"resultframe\" href=\"" + actionurl + "&callid=" + cid + "&submit=Switch\" onclick=\"DelayPhonePoll()\"><img src=\"css/images/blank.png\" border=0 height=75px width=75px alternate=\"Speak to this call\"></a></td>";
                        }
                        else
                        {
                            s += "<td><a target=\"resultframe\" href=\"" + actionurl + "&callid=" + cid + "&submit=Switch\" onclick=\"DelayPhonePoll()\"><img src=\"css/images/switch.png\" border=0 height=75px width=75px alternate=\"Speak to this call\"></a></td>";
                        }
                    }
                    else
                    {
                        s += "<td width=75px></td>";            
                    }
                    // Blank
                    s += "<td width=75px></td>";            
                    
                    // Recording
                    if (getElementTextNS("", "recording", calls[i], 0) == 0)
                    {
                        s += "<td><a target=resultframe href=" + actionurl + "&callid=" + cid + "&submit=Record onclick=DelayPhonePoll()><img src=\"css/images/record.png\" border=0 height=75px width=75px alternate=\"Record\"></a></td>";
                    }
                    else
                    {   
                        s += "<td><a target=resultframe href=" + actionurl + "&callid=" + cid + "&submit=Record onclick=DelayPhonePoll()><img src=\"css/images/recordactive.png\" border=0 height=75px width=75px alternate=\"Cancel Recording\"></a></td>";   
                    }
                    s += "</tr>";
                    
                    // Ringing and direct to VM
                    if (cstat == 9)
                    {
                        s += "<tr>";
                        s += "<td><a target=resultframe href=" + actionurl + "&callid=" + cid + "&submit=vm onclick=DelayPhonePoll()><img src=\"css/images/transfervm.png\" border=0 height=75px width=75px alternate=\"Transfer to VM\"></a><td>";
                        s += "<td width=75px></td>";
                        s += "<td width=75px></td>";
                        s += "<td width=75px></td>";
                        s += "</tr>";
                    }
                    // Multiple Calls Handling
                    if(calls.length == 2 && i==1)
                    {
                        s += "<tr>";
                        // Confernece
                        if (conferenceInProgress == true)
                        {
                            s += "<td><a target=\"resultframe\" href=\"" + actionurl + "&callid=" + currentcall + "&submit=Conf\" onclick=DelayPhonePoll()><img src=\"css/images/conferencea.png\" border=0 height=75px width=75px alternate=\"Breakup Conference\"></a></td>";
                        }
                        else
                        {
                            s += "<td><a target=\"resultframe\" href=\"" + actionurl + "&callid=" + currentcall + "&submit=Conf\" onclick=DelayPhonePoll()><img src=\"css/images/conference.png\" border=0 height=75px width=75px alternate=\"Conference\"></a></td>";					
                        }			
                        // Transfer
                        s += "<td><a target=\"resultframe\" href=\"" + actionurl + "&callid=" + currentcall + "&scallid=" + altcall + "&submit=Connect\" onclick=\"DelayPhonePoll()\"><img src=\"css/images/transfer.png\" border=0 height=75px width=75px alternate=\"Complete Transfer\"></a></td>";
                        // Blank
                        s += "<td width=75px></td>";
                        // Blank
                        s += "<td width=75px></td>";
                        s += "</tr>";
                    }                
                    s += "</table>";
                }
                
            }
            else
            {   
                SetPhoneUpdateTimer(15000);
                s += "<ul><li>No calls are active</li></ul>";   
            }
        }
        catch (err)
        {
            s += "<ul><li>Unable to contact your system</li></ul>"
        }
    }
    else
    {   //H323 or Sip
        //s = "H323 / SIP Reponse"; 
        
        s = "<table border=1 cellspacing=0 cellpadding=3>";
        var connected = getElementTextNS("", "connected", req.responseXML, 0);
        
        var calls = req.responseXML.getElementsByTagName("call");
        if (connected == 0)
        {
            s += "<tr><td>Unable to contact remote unit at the moment, system will attempt to reconnect in a second.</td></tr>";    
            SetPhoneUpdateTimer(3000);
        }        
        else if (calls.length > 0)
        {   
            SetPhoneUpdateTimer(5000);
            for (var i = 0; i < calls.length; i++) 
            {
                //var cid = getElementTextNS("", "callid", calls[i], 0) ;
                //var cstat = getElementTextNS("", "state", calls[i], 0) ;
                if (getElementTextNS("", "targets", calls[i], 0) == "")
                {
                    s += "\n<tr gbgcolor=lightyellow><td><img src=Images/Splice/idle.png  border=0></td>";
                }
                else
                {
                    s += "\n<tr gbgcolor=lightyellow><td><img src=Images/Splice/ringing.png  border=0></td>";
                }
                
                s += "<td>" + getElementTextNS("", "sourceName", calls[i], 0) + "</td><td>" + getElementTextNS("", "sourceNumber", calls[i], 0) + "</td><td>" + getElementTextNS("", "targetName", calls[i], 0) + "</td><td>" + getElementTextNS("", "targetNumber", calls[i], 0) + "</td><tr>";
            }
        }
        else
        {
            SetPhoneUpdateTimer(15000);
            s += "<li>No calls are currently active</li>";
        }
        s+= "</ul>";
    }
    document.getElementById("details").innerHTML = s;
}
//Alt AJAX Global - For independant 

var areq;

function aloadXMLDoc(url,type) {
    if (window.XMLHttpRequest) {
        if (areq != null)
        {
            try
            {
                areq.onreadystatechange = null;
                areq.abort();    
            }
            catch (errr)
            {
                alert(errr);                    
            }
        }
        areq = new XMLHttpRequest();
        areq.onreadystatechange = aprocessReqChange;
        areq.open("GET", url, true);
        areq.send(null);
    } else if (window.ActiveXObject) {
        isIE = true;
        areq = new ActiveXObject("Microsoft.XMLHTTP");
        if (areq) {
            areq.onreadystatechange = aprocessReqChange;
            areq.open("GET", url, true);
            areq.send();
        }
    }
}

function aprocessReqChange() {
    if (areq != null)
    {
        if (areq.readyState == 4) {
			try
			{
				if (areq.status == 200) {
					aipxresponse(0);
				}
			}
			catch (err) 
			{
			
			}			
            //else { "There was a problem retrieving the XML data:\n" + areq.statusText; }
        }
    }
    // else  { document.getElementById("ajax_loading").style.visibility = "visible";  }
}
function call(atelno)
{
    showMakeCall(atelno);
    try
    {   
        document.forms['webphoneForm'].telno.value = atelno;
        document.forms['webphoneForm'].submitcall.click();
        //document.webphoneForm.submit();
    }
    catch (err)
    {
        //alert(err);
        document.getElementById("contacts").innerHTML = err;
    }
}

var DelayAReqId = 0;
var DelayLoadAReqCommand = "LoadContacts();";
function DelayLoadAReq()
{
    if (DelayAReqId != 0)
    {
        window.clearTimeout(DelayAReqId);
    }
    DelayAReqId = window.setTimeout(DelayLoadAReqCommand,500);
}

var EditContact = true;

function LoadContacts()
{
    try
    {
        var a_url = contacturl + '&search=' + document.forms['webphoneForm'].telno.value;
        aloadXMLDoc(a_url);
    }
    catch (err)
    {
        //alert('loadcontacts err:: ' + err);
    }
}

function IsNumeric(sText)
{
    var ValidChars = "0123456789.-*#";
    var IsNumber=true;
    var Char;
    for (i = 0; i < sText.length && IsNumber == true; i++) 
    { 
        Char = sText.charAt(i); 
        if (ValidChars.indexOf(Char) == -1) 
        {
            IsNumber = false;
        }
    }
    return IsNumber;
}

function ContactFormat(name,record, field)
{
    var vals = getElementTextNS("", field, record, 0);
    if ( vals != "")
    {
        return "<li class=\"contactrow\"><a href=# onclick=\"call('" + vals + "'); return false;\"><span class=\"secondaryNameLink\"><p>" + name + "</p></span><span class=\"secondaryWLink\">" + vals + "</span></a></li>";
    }
    return "";
}

function aipxresponse(format)
{
    var s = "";
    try
    {
        var contacts = areq.responseXML.getElementsByTagName("contact");
        if (contacts.length > 0)
        {   
             s += "<ul class=\"contact\">";
//            s += "<li>";
//            s += "Name<span class=\"secondaryWLink\">Number</span>";
//            s += "</li>";
            
            for (var i = 0; i < contacts.length; i++) 
            {
                name="";
                var con_type = getElementTextNS("", "objectclass", contacts[i], 0);
                //var telLength = getElementTextNS("", "telephoneNumber", contacts[i], 0).length;
                if (format == 0 && (con_type == "User" || con_type == "Department" || con_type == "SpeedDial" ) )
                {
                    if ( getElementTextNS("", "blfState", contacts[i], 0) == "rg")
                    {
                        name += "<img src=Images/Splice/ringing.png alt='Ringing' border=0> ";
                    }
                    else if ( getElementTextNS("", "blfState", contacts[i], 0) == "bz")
                    {
                        name += "<img src=Images/Splice/busy.png alt='Busy' border=0> ";
                    }
                    else
                    {
                        name += "<img src=Images/Splice/idle.png alt='Idle' border=0> ";
                    }
                }
                name += getElementTextNS("", "cn", contacts[i], 0);

                    
                if (con_type  == "SpeedDial")
                {   //Speed Dials
                    s += ContactFormat(name,contacts[i],"telephoneNumber");
                }
                else if (con_type == "User")
                {   //Users
                    s += ContactFormat(name,contacts[i],"telephoneNumber");
                    name = ":";
                    s += ContactFormat(name,contacts[i],"homeTelephone");
                    s += ContactFormat(name,contacts[i],"mobileTelephone");
                    s += ContactFormat(name,contacts[i],"spare1Telephone");
                    s += ContactFormat(name,contacts[i],"spare2Telephone");    
                }
                else if (con_type == "Department" )
                {   //Users
                    s += ContactFormat(name,contacts[i],"telephoneNumber");
                }
                else if (con_type == "Contact")
                {   //Contacts
                    s += ContactFormat(name,contacts[i],"telephoneNumber");
                    name = ":";
                    s += ContactFormat(name,contacts[i],"homeTelephone");
                    s += ContactFormat(name,contacts[i],"mobileTelephone");
                    s += ContactFormat(name,contacts[i],"spare1Telephone");
                    s += ContactFormat(name,contacts[i],"spare2Telephone");    
                }
            }
            vals = document.forms['webphoneForm'].telno.value;
            if ( IsNumeric(vals) )
            {
                s += "<li><a href=# onclick=\"call('" + vals + "'); return false;\">Call<span class=\"secondaryWLink\">" + vals + "</span></a></li>";
            }
        }
        else if ( document.forms['webphoneForm'].telno.value )
        {   
            vals = document.forms['webphoneForm'].telno.value;
            if ( IsNumeric(vals) )
            {
                s += "<li><a href=# onclick=\"call('" + vals + "'); return false;\"> Call <span class=\"secondaryWLink\">" + vals + "</span></a></li>";
            }
            else
            {
                s += "<li>No contacts match: "+ document.forms['webphoneForm'].telno.value + "</li>";
            }
        }
        
        if(s.length>0)
            s+= "</ul>";
        
        if (format == 1 && contacts.length == 1)
        {
            if (getElementTextNS("", "voicemail", contacts[0], 0) == 1)
            {
                document.MessageForward.SendToMailboxBtn.disabled = false;                
            }
            if (getElementTextNS("", "mail", contacts[0], 0) != "")
            {
                document.MessageForward.SendByEmailBtn.disabled = false;
            }
        }        
    }
    catch (err)
    {
        if (format ==1 )
        {   
            s += "<ul>";
            s += "<li>Unable to contact your system</li>";
            s += "<li>" + err + "</li>" ;  
            s += "</ul>";
            //s += areq.responseText;
        }
    }
    document.getElementById("contacts").innerHTML = s;
}

// VM 

function LdapSearch(searchType)
{
    try
    {
        if (document.forms["MessageForward"].search.value.indexOf('@') == -1)
        {            
            var url = searchurl + '&search=' + document.forms["MessageForward"].search.value;
            if (window.XMLHttpRequest) {
                areq = new XMLHttpRequest();
                if (searchType == 0)
                    areq.onreadystatechange = vmReqChange;
                else
                    areq.onreadystatechange = vrReqChange;
                areq.open("GET", url, true);
                areq.send(null);
            } else if (window.ActiveXObject) {
                isIE = true;
                areq = new ActiveXObject("Microsoft.XMLHTTP");
                if (areq) {
                    if (searchType == 0)
                        areq.onreadystatechange = vmReqChange;
                    else
                        areq.onreadystatechange = vrReqChange;
                    areq.open("GET", url, true);
                    areq.send();
                }
            }   
        } 
        else
        {
            document.MessageForward.SendByEmailBtn.disabled = false;
        }
    }
    catch (err)
    {
        alert('VMSearch err:: ' + err);
    }
}

function vmReqChange() {
    if (areq != null)
    {
        if (areq.readyState == 4) {
            if (areq.status == 200) {
                aipxresponse(1);
            } 
            //else { "There was a problem retrieving the XML data:\n" + areq.statusText; }
        } 
        // else  { document.getElementById("ajax_loading").style.visibility = "visible";  }    
    }    
}

function vrReqChange() {
    if (areq != null)
    {
        if (areq.readyState == 4) {
            if (areq.status == 200) {
                aipxresponse(2);
            } 
            //else { "There was a problem retrieving the XML data:\n" + areq.statusText; }
        } 
        // else  { document.getElementById("ajax_loading").style.visibility = "visible";  }    
    }    
}

//Option 1 = mailbox 2=mail
function VMFindDetails(option)
{ 
    try
    {
        if (document.forms["MessageForward"].search.value.indexOf('@') == -1)
        {
            var contacts = areq.responseXML.getElementsByTagName("contact");
            if (contacts.length==1)
            {
                //alert('VM FIND DETAILScn(' + getElementTextNS("", "cn", contacts[0], 0) + ')guid('+ getElementTextNS("", "guid", contacts[0], 0) + ')mail('+ getElementTextNS("", "mail", contacts[0], 0)+ ')');
                if (option == 1)
                {
                    
                    SendVM2Mailbox(getElementTextNS("", "GUID", contacts[0], 0),getElementTextNS("", "cn", contacts[0], 0));
                }
                else
                {
                    SendVM2Email(getElementTextNS("", "mail", contacts[0], 0));
                }
            }    
        }
        else
        {
            SendVM2Email(document.forms["MessageForward"].search.value);            
        }        
    }
    catch (err)
    {
        alert('error');
    }
}

function SendVM2Mailbox(guid,cn)
{
    var url = forwardurl + '&destguid=' + guid + '&cn=' + cn;
    frames['actionframe'].location.href = url;
}

function SendVM2Email(email)
{
    var url = forwardurl + '&emailto=' + email;
    frames['actionframe'].location.href = url;
}

// Quick Dial


var DelayQReqId = 0;
var DelayLoadQReqCommand = "qloadAjax();";
function DelayLoadQReq()
{
    if (DelayQReqId != 0)
    {
        window.clearTimeout(DelayQReqId);
    }
    DelayQReqId = window.setTimeout(DelayLoadQReqCommand,1000);
}


var qreq;

function qloadAjax()
{
    if (window.XMLHttpRequest) {
        qreq = new XMLHttpRequest();
        qreq.onreadystatechange = qReqChange;
        qreq.open("GET", quickdialurl, true);
        qreq.send(null);
    } else if (window.ActiveXObject) {
        isIE = true;
        qreq = new ActiveXObject("Microsoft.XMLHTTP");
        if (qreq) {
            qreq.onreadystatechange = qReqChange;
            qreq.open("GET", quickdialurl, true);
            qreq.send();
        }
    }        
}

function qReqChange()
{
    if (qreq != null)
    {
        if (qreq.readyState == 4) {
            if (qreq.status == 200) {
                QuickDial();
                document.getElementById("qajax_loading").style.visibility = "hidden";
                DelayLoadQReq();
            } 
            else if (qreq.status >= 400)
            {
                document.getElementById("qajax_loading").style.visibility = "hidden";
                document.getElementById("qajax_failed").style.visibility = "visible";
            }
        }
        else
        {
            if (document.getElementById("qajax_loading") != null)
            {
                document.getElementById("qajax_loading").style.visibility = "visible";
                document.getElementById("qajax_failed").style.visibility = "hidden";
            }
        }
    }
}

function QuickDial()
{
    var entry = qreq.responseXML.getElementsByTagName("Entry");
    var s= "<ul>";
    if (entry.length > 0)
    {   
        
        for (var i = 0; i < entry.length; i++) 
        {
            var cn = getElementTextNS("", "cn", entry[i], 0) ;
            var telephoneNumber = getElementTextNS("", "telephoneNumber", entry[i], 0) ;
            var blfState = getElementTextNS("", "blfState", entry[i], 0);
            
            if (blfState == "bz")
            {
                s += "<li><img src=Images/Splice/busy.png alt='Busy' border=0><font color=red> " + cn + "</font></li>";
            }
            else if (blfState == "rg")
            {
                if (phonetype == "0")
                {
                    var lnk = "<a target=\"resultframe\" href=\"" + actionurl + "&name=" + telephoneNumber + "&tel=" + telephoneNumber + "&submit=PickUp\" onclick=\"DelayPhonePoll()\">";
                    s += "<li>" + lnk + "<img src=Images/Splice/ringing.png alt='Ringing' border=0><font color=orange> " + cn + "</font></a></li>";                    
                }
                else
                {
                    s += "<li><img src=Images/Splice/ringing.png alt='Ringing' border=0><font color=orange> " + cn + "</font></li>";                    
                }
            }
            else 
            {
                var lnk = "<a href=# onclick=\"call('" + telephoneNumber + "');return false\">";
                s += "<li>" + lnk + "<img src=Images/Splice/idle.png alt='Idle' border=0><font color=green> " + cn + "</font></a></li>";
            }
        }
    }
    s += "</ul>";
    document.getElementById("quickdialdiv").innerHTML = s;
}

function TCvalidateNumeric(txtField,length)
{
    var strValidChars = "0123456789";
    var strChar;
    var strString;
    var blnResult = true;
    
    strString = txtField.value;
    
    if (strString.length == 0) 
        return false;
    
    var alarm = false;
    var alarmtxt = "";
    //  test strString consists of valid characters listed above
    for (i = 0; i < strString.length && blnResult == true; i++)
    {
        strChar = strString.charAt(i);
        if (strValidChars.indexOf(strChar) == -1)
        {
            alarm = true;
            alarmtxt = "Sorry this field will only accept 4 digit numbers";
        }
    }
    
    if (alarm == false && strString.length > length)
    {
        alarm = true;
        alarmtxt = "Sorry this field will only accept 4 digit numbers";
    }
    
    if (alarm == true)
    {
        if (txtField.style.background != "pink")
        {   
            alert(alarmtxt);
            txtField.style.background = "pink";
        }
    }
    else
    {
        txtField.style.background = "white";
    }
    
    return blnResult;
}
