$(document).ready(function() {
	
	$('#ccccdiv').on('select_node.jstree', function (e, data) {
		var instance = $(this).jstree(true);
		
		if (data.node.original.folder == "0") {
			// for a click on a code, submit it
			var extend = data.node.original.extend;
			console.log("code="+data.node.id+" extend="+extend);
			
			var req = window.location.href.replace('pagename=wrapup2','pagename=setWrapUp') + "&code="+data.node.id;
			
			if( extend == 0 )
				$('#ccccdiv').hide();
				
			$.ajax(req, {
				error: function (jqXHR, textStatus, errorThrown) {
					alert(errorThrown);
				},
				success: function (data, textStatus, jqXHR) {
					if (extend > 0)
						console.log('wrapup extended');
					else
						console.log("code submitted");
				},
				timeout: 5000
			});
		} else {
			// for a click on a folder, toggle its open/close state
			instance.toggle_node(data.node);
		}
	})
	.jstree({
		plugins : ["types"],
		core : {
			'check_callback' : true,
			'data' : {
				'url' : window.location.href.replace('pagename=wrapup2','pagename=getcccc')
			}
		},
		types : {
			"extend_type" : {
				a_attr :  { "has_extend" : "1" }
			}
		}
	});
});
