
function delclick() {
	var ret = window.confirm("Are you sure you want to delete the selected call records and recordings ?");
	if ( !ret )
		return;
			
	var search = location.search.substring(1);
	var obj2 = JSON.parse('{"' + decodeURI(search).replace(/"/g, '\\"').replace(/&/g, '","').replace(/=/g,'":"') + '"}');
	
	var url = window.location.origin + window.location.pathname + "?pagename=deldata&sessionId=" + obj2.sessionId;

	var dataObj = new Object;
	
	$("input:checked").filter(".cb_dataid,.cb_recid").each(function (ix,e) {
		var cb = $(this);
		var nm = cb.attr("name");
		dataObj[nm] = "del";
	});
	
	dataObj["reason"] = $("#reason").val();
	
	// the JQuery default CONTENT-TYPE of "application/x-www-form-urlencoded; charset=UTF-8" will prevent parsing of POST data in Vision.cgi
	$.ajaxSetup({contentType: "application/x-www-form-urlencoded"});
	
	$.post(url,dataObj,function (data, textStatus, jqXHR) {
		
		if ((typeof data.result != "undefined") && (data.result != "OK") && (typeof data.reason != "undefined"))
			alert(data.reason);
		else if ((typeof data.result == "undefined") || (data.result != "OK"))
			alert("Deletion error")
			
		window.location.reload(true);
	});
}

function set_data_del(sel, chk) {
	sel.prop("checked",chk);
	
	// if data is to be deleted, recording must also be deleted ...
	if (chk)
		sel.parent().prev().find("input.cb_recid").prop("checked",true);
}

function set_rec_del(sel, chk) {
	sel.prop("checked",chk);
	
	// if recording is not to be deleted, data must also not be deleted ...
	if (!chk)
		sel.parent().next("td").find("input.cb_dataid").prop("checked",false);
}

$(document).ready(function() {

	var hdr_row = $("table.visionList tr.HeaderRow");
	if (hdr_row) {
		var span1 = hdr_row.children('td').length - 9;
		if ($("table.visionList tr.DataRow").length > 12)
			hdr_row.before("<tr class=\"delrow3\"><td colspan=\""+span1+"\"></td><td colspan=\"2\" class=\"reasontxt\">Reason / Ref</td><td colspan=\"5\"><input id=\"reason2\" type=\"text\" class=\"reason\"></td><td colspan=\"2\"><img src=\"Images/Splice/delete.png\" onclick=\"delclick()\"></td></tr>");
		var span2 = hdr_row.children('td').length - 2;
		hdr_row.before("<tr class=\"delrow1\"><td colspan=\""+span2+"\"></td><td colspan=\"2\">Delete</td></tr><tr class=\"delrow2\"><td colspan=\""+span2+"\"></td><td>Rec</td><td>Data</td></tr>");
	}
	
	var last_row = 	$("table.visionList tr.DataRow").last();
	if (last_row ) {
		var span3 = last_row.children('td').length - 9;
		last_row.after("<tr class=\"delrow3\"><td colspan=\""+span3+"\"></td><td colspan=\"2\" class=\"reasontxt\">Reason / Ref</td><td colspan=\"5\"><input id=\"reason\" type=\"text\" class=\"reason\"></td><td colspan=\"2\"><img src=\"Images/Splice/delete.png\" onclick=\"delclick()\"></td></tr>");
	}

	$(".reasontxt").css("text-align","right");
	$(".reasontxt").css("padding-right","10px");

	$("input.reason").keyup(function (ev) {
		var obj = this;
		var newval = $(this).val();
		$("input.reason").each(function(i, el) {
			if (this != obj)
				$(this).val(newval);
		});
	});
	$("input.cbhdr_recid").click(function (e) {
		if( $(this).prop("checked") )
			$(".cb_recid").prop("checked",true);
		else
			$(".cb_recid,.cb_dataid,.cbhdr_dataid").prop("checked",false);
	});
	$("input.cbhdr_dataid").click(function (e) {
		if( $(this).prop("checked") )
			$(".cb_recid,.cb_dataid,.cbhdr_recid").prop("checked",true);
		else
			$(".cb_dataid").prop("checked",false);
	});
	$("input.cb_recid").click(function (e) {
		var chk = $(this).prop("checked");
		set_rec_del($(this), chk);
		
		// set any other recording checkboxes with the same name to the same check-state
		$('.cb_recid').filter('[name="'+$(this).attr("name")+'"]').not(this).each(function (obj) {
			set_rec_del($(this), chk);
		});
	});
	$("input.cb_dataid").click(function (e) {
		var chk = $(this).prop("checked");
		set_data_del($(this), chk);
		
		// if there are other rows with matching recording name, set the data checkbox in these rows to the same check-state
		var rec_name = $(this).parent().prev().find("input.cb_recid").attr("name");
		if (typeof rec_name != "undefined") {
			$("input.cb_recid").filter('[name="'+rec_name+'"]').parent().next().find("input.cb_dataid").not(this).each(function (obj) {
				set_data_del($(this), chk);
			});
		}
	});
});

