// Check specific form fields do not have characters that are a problem for unescaped JSON encoding.

var regexlist = [
	{r:/\t/, m:" contains a tab"},
	{r:/\s$/, m:" has trailing white-space"}
];

$(document).ready(function() {
	$(".formsubmit").click(function (e) {
		var valid = true;
		$(".jsontext").each(function (ix) {
			var v = $(this).val();
			var fieldname = $(this).attr("name");
			regexlist.forEach(function(item, index, array) {
				if (item.r.test(v)) {
					console.log("field " + fieldname + item.m);
					valid = false;
				}
			});
		});
		if (!valid)
			alert("Illegal character in input field");
		return valid;
	});
})
